<?php
Class wiki
{ 
// lire un fichier
function lire_fichier($fichier){
     $texte ="";
     if (file_exists($fichier)) {
         $tableau = file($fichier);
         while(list($cle,$val) = each($tableau)) {
             $texte .= $val;
            }
        }
     return stripslashes($texte);
    }
// fin
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//lire article
function lire_article($page,$page_conf){
     if ($page == "./data/") {
         $texte = $this -> lire_fichier("./data/index.txt");
         $page = "./data/index";
        } else $texte = $this -> lire_fichier($page.".txt");
     if (file_exists($page.".txt") == false)  $texte = $this->lire_fichier("./erreur/2.txt");
     // modules
     preg_match_all("#\[\[([a-z_]+)(\|(.+))?\]\]#isU",$texte,$mod);
     for ($i = 0;$i <= sizeof($mod[1])-1;$i++){
     // verification que les fichiers obligatoires du plugins existe
     if (file_exists("./module/".$mod[1][$i]."/".$mod[1][$i].".php")) {
         require_once("./module/".$mod[1][$i]."/".$mod[1][$i].".php");
         if (function_exists("plugin_".$mod[1][$i])){
              if (isset($mod[3][$i]) == false) $mod[3][$i] = "";
             // parametre 
             $param = $mod[3][$i];
             $texte = preg_replace("#\[\[".$mod[1][$i]."\|?".$mod[3][$i]."\]\]#isU",eval("return plugin_".$mod[1][$i]."(\$page_conf,\$param);"),$texte);
	        }
        }
     }
// fin modules
     return $texte;
    }
//fin
//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//lire un fichier retourne une liste
function lire_fichier_liste($fichier){
     if (file_exists($fichier)) {
         $tableau = file($fichier);
        }
     return $tableau;
    }
//fin
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// crire un fichier
function ecrire_fichier($fichier,$texte) {
     $inF = fopen($fichier,"w");
     fwrite($inF,$texte);
     fclose($inF);
    }
// fin
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// cryptage et decryptage
function GenerationCle($Texte,$CleDEncryptage)
  {
  $CleDEncryptage = md5($CleDEncryptage);
  $Compteur=0;
  $VariableTemp = "";
  for ($Ctr=0;$Ctr<strlen($Texte);$Ctr++)
    {
    if ($Compteur==strlen($CleDEncryptage))
      $Compteur=0;
    $VariableTemp.= substr($Texte,$Ctr,1) ^ substr($CleDEncryptage,$Compteur,1);
    $Compteur++;
    }
  return $VariableTemp;
  } 

function Crypte($Texte,$Cle)
  {
  srand((double)microtime()*1000000);
  $CleDEncryptage = md5(rand(0,32000) );
  $Compteur=0;
  $VariableTemp = "";
  for ($Ctr=0;$Ctr<strlen($Texte);$Ctr++)
    {
    if ($Compteur==strlen($CleDEncryptage))
      $Compteur=0;
    $VariableTemp.= substr($CleDEncryptage,$Compteur,1).(substr($Texte,$Ctr,1) ^ substr($CleDEncryptage,$Compteur,1) );
    $Compteur++;
    }
  return base64_encode($this -> GenerationCle($VariableTemp,$Cle) );
  } 

function Decrypte($Texte,$Cle)
  {
  $Texte = $this -> GenerationCle(base64_decode($Texte),$Cle);
  $VariableTemp = "";
  for ($Ctr=0;$Ctr<strlen($Texte);$Ctr++)
    {
    $md5 = substr($Texte,$Ctr,1);
    $Ctr++;
    $VariableTemp.= (substr($Texte,$Ctr,1) ^ $md5);
    }
  return $VariableTemp;
  } 
// fin
//----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// lire fichier de configuration MonWiki
function lire_configuration($fichier){
     $tableau = $this -> lire_fichier_liste($fichier);
     for ($i = 0;$i<= sizeof ($tableau)-1;$i++){
         eregi('\[(.+)\]="(.+)";',$tableau[$i],$regs);
         $conf[$regs[1]] = $regs[2];
        }
     return $conf;
    }
//fin
//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//  traduire temps
function temps($date,$type) {
     if ( !function_exists('version_compare') || version_compare( phpversion(), '5', '>' ) ) {
         date_default_timezone_set("Europe/Paris");
        }
     if ($type == 1) return date("d-m-Y",$date);
     if ($type == 2) return date("YmdHis",$date);
    }
//fin
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//lister un repertoire ,date dernire modification ,nom fichier => repertoire_liste($nomrepertoire) = $tableau[$i]["nom"] ou $tableau[$i]["modification"]
function repertoire_liste($repertoire){
     $i = 0;
     $dossier = opendir($repertoire);
     while ($Fichier = readdir($dossier)) {
         if ($Fichier != "." && $Fichier != ".."){
             $nomFichier = $repertoire."/".$Fichier;
             $tableau[$i]["nom"] = $Fichier;
             $tableau[$i]["modification"] = $this->temps(filemtime($nomFichier),1);
             $tableau[$i]["modif_search"] = $this->temps(filemtime($nomFichier),2);
             $i = $i+1;
            }
        }
     closedir($dossier);
     return $tableau;
    }
//fin
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// url paramtre
function url_parametre($param){
     $temp = explode("&",$param);
     for ($i = 0;$i <= sizeof($temp)-1;$i++){
         $get_tmp = explode("=",$temp[$i]);
         $get[$get_tmp[0]] = $get_tmp[1];
        }
     return $get;
    }
//fin url_parametre
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// verification si il y a de nouveau module
function upgrade() {
     // initialisation variable
     $texte = "";
	 $texte_conf = "";
     // recupration de la dernire liste des plugins
     $liste_texte = $this -> lire_fichier_liste("liste_plugin.txt");
     // listage des modules presents maintenant
     $liste_reel = $this -> repertoire_liste("./module");
     // verification si il y a de nouveaux modules
     for ($i = 0;$i <= sizeof($liste_reel)-1 ;$i++){
	     $temp = 0;
         for ($a = 0;$a <= sizeof($liste_texte)-1;$a++){
		     preg_match("#\[(.+)\]#isU",$liste_texte[$a],$mod);
		     if (preg_match("#^".$mod[1]."$#",$liste_reel[$i]["nom"])) $temp = 1;
            }
		 if ($temp != 1) {
		     $texte .= '<span style="color:red">Installation/D&eacute;sinstallation: </span>'.$liste_reel[$i]["nom"]."<br/>\n";
			 // verification qu'il y a un fichier d'installation
			 if (file_exists("./module/".$liste_reel[$i]["nom"]."/installation.php")){
			     // execution du fichier installation.php
			     eval($this -> lire_fichier("./module/".$liste_reel[$i]["nom"]."/installation.php"));
				 // on efface le fichier d'installation
				 unlink("./module/".$liste_reel[$i]["nom"]."/installation.php");
			    }
			}
		 $texte_conf .= "[".$liste_reel[$i]["nom"]."]
";
        }
	 // ecrire fichier liste_plugin.txt
	 $this -> ecrire_fichier("liste_plugin.txt",$texte_conf);
     return $texte;
    }
// fin upgrade
}
?>